//////////////////////////////////////////////////////////////////////
//
//  LULDEMO.PRG
//
//  Copyright: Copyright (C) combit GmbH
//
//  Content:
//  D: Hauptroutine fuer List & Label Rechnungsbeispiel
//  US: Main routine for List & Label invoice sample
//
//  Xbase++ compile:
//     PBUILD /A
//  D: Alle List & Label spezifischen Routinen befinden sich in LULMENU.PRG und ..\LLCOMMON.PRG
//  US: All List & Label specific routines are found in LULMENU.PRG and ..\LLCOMMON.PRG
//////////////////////////////////////////////////////////////////////


#include "Gra.ch"
#include "Xbp.ch"
#include "common.ch"
#include "AppEvent.ch"
#include "cmbtll25.ch"


PROCEDURE Main()
   LOCAL nEvent := xbe_None, mp1 := 0, mp2 := 0, oXbp := 0
   PRIVATE oListBox, lDebugOutput := .F.
   SET DATE TO SYSTEM
   SET DELETED ON

   CreateMainWindow()

   SetAppWindow():show()
   SetAppFocus( SetAppWindow())

   DO WHILE nEvent <> xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:handleEvent( nEvent, mp1, mp2 )
   ENDDO
   SetAppWindow():destroy()
   CLOSE ALL
   Quit
RETURN


PROCEDURE CreateMainWindow()
   LOCAL nHeight := 330, nWidth := 610 // Tom Liehr
   LOCAL aSize    := AppDesktop():currentSize()
   LOCAL aPos := {Int( (aSize[1]-nWidth ) / 2 ), Int( (aSize[2]-nHeight) / 2 )}
   LOCAL oDlg, oStatic, oXbp
   LOCAL oButton

   oDlg := XbpDialog():new()
   oDlg:title    := "List & Label 20 Xbase++ - Demo"
   oDlg:border   := XBPDLG_DLGBORDER
   oDlg:taskList := .T.
   oDlg:maxButton:= .F.
   oDlg:create( ,, aPos, {nWidth, nHeight},, .F. )

   MenuCreate( oDlg:menuBar() )

   oStatic := XbpStatic():new( oDlg:DrawingArea,, {12, 243},  {456, 20} )
   oStatic:caption := "D:  Dieses Beispiel demonstriert das Designen und Drucken von Rechnungen"
   oStatic:create()

   oStatic := XbpStatic():new( oDlg:DrawingArea,, {12, 207},  {456, 20} )
   oStatic:caption := "US: This example demonstrates how to design and print invoices"
   oStatic:create()


   oStatic := XbpStatic():new( oDlg:DrawingArea,, {12, 48},  {586, 143} ) // Tom Liehr
   oStatic:caption := "Select Invoice:"
   oStatic:type := XBPSTATIC_TYPE_GROUPBOX
   oStatic:create()

   MEMVAR->oListBox := XbpListbox():new( oStatic,, {12, 6}, {oStatic:currentSize()[1]-24, oStatic:currentSize()[2]-24} )
   MEMVAR->oListBox:multiSelection := .F.
   MEMVAR->oListBox:create()
   MEMVAR->oListBox:itemSelected:= {|| PrintInvoice() }
   LoadInvoices()


   oButton := XbpPushButton():new(oDlg:DrawingArea,, {12, 12},  {100, 24} )
   oButton:caption := "Design (Std.)"
   oButton:create()
   oButton:activate:= {|uNIL1, uNIL2, oObj| oObj:disable(), PrintInvoice(,.T.), oObj:enable() }

   oButton := XbpPushButton():new(oDlg:DrawingArea,, {132, 12},  {100, 24} )
   oButton:caption := "Design (real data)"
   oButton:create()
   oButton:activate:= {|uNIL1, uNIL2, oObj| oObj:disable(), InvoiceDesignRD(memvar->oListBox:GetData()[1]), oObj:enable() }

   oButton := XbpPushButton():new(oDlg:DrawingArea,, {252, 12},  {100, 24} )
   oButton:caption := "Preview"
   oButton:create()
   oButton:activate:= {|uNIL1, uNIL2, oObj| oObj:disable(), PrintInvoice(), oObj:enable()  }

   oButton := XbpPushButton():new(oDlg:DrawingArea,, {372, 12},  {100, 24} )
   oButton:caption := "Export"
   oButton:create()
   oButton:activate:= {|uNIL1, uNIL2, oObj| oObj:disable(), PrintInvoice(LL_PRINT_EXPORT), oObj:enable()  }

   // D: Debugoption setzen
   // US: Set debug option
   oXbp := XbpCheckbox():new(oDlg:DrawingArea, , {492,12}, {100,24} )
   oXbp:caption := "Debug output"
   oXbp:create()
   oXbp:selected := {| lCheck, uNIL, self | memvar->lDebugOutput := lCheck, IIf(memvar->lDebugOutput,;
                       MsgBox("D: Debwin muss zur Anzeige von Debugausgaben gestartet werden"+chr(13)+;
                              "US: Start Debwin to receive debug messages","Debug option"),Nil) }

   /* ltere Version, gelscht
   // Tom Liehr
   // D: Design mit Echtdaten
   // US: Designer with real data
   PRIVATE lDesignRealData := .T.
   oXbp := XbpCheckbox():new(oDlg:DrawingArea, , {612,12}, {100,24} )
   oXbp:caption := "Real data design"
   oXbp:create()
   oXbp:SetData(lDesignRealData)
   oXbp:selected := {| lCheck, uNIL, self | memvar->lDesignRealData := lCheck, IIf(memvar->lDesignRealData,;
                       MsgBox("D: Designer mit Echtdaten aktiv"+chr(13)+;
                              "US: Designer with real data active","Designer option"),Nil) } */

   SetAppWindow( oDlg )
RETURN

// D: Menuesystem erzeugen
// US: Create menu-system
//-------------------------------------------------------------------
STATIC PROCEDURE MenuCreate( oMenuBar )
//-------------------------------------------------------------------
   LOCAL oMenu

   // D: Menue erzeugen
   // US: Create menu
   oMenu := XbpMenu():new( oMenuBar ):create()
   oMenu:title := "Help"
   oMenu:addItem( { "~About",  {|| AboutBox() } } )

   oMenuBar:addItem( {oMenu, NIL} )

RETURN

STATIC PROCEDURE AboutBox()
 ConfirmBox(SetAppWindow() , "List & Label 25 Xbase++ Demo (c) combit GmbH", "About", XBPMB_OK , XBPMB_INFORMATION+XBPMB_APPMODAL+XBPMB_MOVEABLE )
RETURN


// D: XbpListBox mit Daten fuellen
// US: Fill XbpListBox with data
PROCEDURE LoadInvoices()
LOCAL cListEntry

USE &(GetDataPath()+"\INVOICE") NEW
GO TOP
DO WHILE !EOF()
  cListEntry:= "No. "+FieldGet(1)
  cListEntry+=" from "+DTOC(FieldGet(2))
  cListEntry+=", "+FieldGet(3)
  MEMVAR->oListBox:AddItem(cListEntry)
  DBSkip()
ENDDO
Use
MEMVAR->oListBox:SetData({1})
RETURN

// D: Standardmaessiges Xbase++ Fenster nicht erzeugen - wird nicht gebraucht
// US: Don't create default Xbase++ window - it's not needed
PROCEDURE AppSys()
RETURN
